//
//  ListTwoColumnSubsectionDividerModel.swift
//  MVMCoreUI
//
//  Created by Lekshmi S on 07/04/20.
//  Copyright © 2020 Verizon Wireless. All rights reserved.
//

import Foundation


public class ListTwoColumnSubsectionDividerModel: ListItemModel, MoleculeModelProtocol {
    //------------------------------------------------------
    // MARK: - Properties
    //------------------------------------------------------
    
    public static var identifier: String = "list2CSbscDiv"
    public var leftLabel: LabelModel
    public var rightLabel: LabelModel
    
    //------------------------------------------------------
    // MARK: - Initializer
    //------------------------------------------------------
    
    public init(leftLabel: LabelModel, rightLabel: LabelModel) {
        self.leftLabel = leftLabel
        self.rightLabel = rightLabel
        super.init()
    }
    
    //------------------------------------------------------
    // MARK: - Method
    //------------------------------------------------------
    
    override public func setDefaults() {
        style = .tallDivider
        super.setDefaults()
    }
    
    //------------------------------------------------------
    // MARK: - Keys
    //------------------------------------------------------
    
    private enum CodingKeys: String, CodingKey {
        case moleculeName
        case leftLabel
        case rightLabel
    }
    
    //------------------------------------------------------
    // MARK: - Codec
    //------------------------------------------------------
    
    required public init(from decoder: Decoder) throws {
        let typeContainer = try decoder.container(keyedBy: CodingKeys.self)
        leftLabel = try typeContainer.decode(LabelModel.self, forKey: .leftLabel)
        rightLabel = try typeContainer.decode(LabelModel.self, forKey: .rightLabel)
        try super.init(from: decoder)
    }
    
    public override func encode(to encoder: Encoder) throws {
        try super.encode(to: encoder)
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(moleculeName, forKey: .moleculeName)
        try container.encode(leftLabel, forKey: .leftLabel)
        try container.encode(rightLabel, forKey: .rightLabel)
    }
}
